VERSION 5.00
Begin VB.UserControl ElusiveProfessor 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "ElusiveProfessor.ctx":0000
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   300
      Top             =   1380
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   435
      Left            =   240
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   660
      Width           =   3015
   End
End
Attribute VB_Name = "ElusiveProfessor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'The Elusive Professor ActiveX Control.
'Almost every single line of code here was created by the ActiveX Control
'Wizard, where I just delegated to a command button included in the control.
'The only thing I did was:
'-create two local variables that would store the original location of the control
'-added code to the Command1_MouseMove method so that it would move
'  the control away from the mouse
'-changed the UserControl_Resize method so that the button
' is always resized to fill the control
'-added a timer that restores things to the way it was
'-added a 15x16 bitmap to the ToolboxBitmap property of the user control

Option Explicit

'Default Property Values:
Const m_def_ForeColor = 0
Const m_def_BackStyle = 0
Const m_def_BorderStyle = 0

'Property Variables:
Dim m_ForeColor As Long
Dim m_BackStyle As Integer
Dim m_BorderStyle As Integer

'Local variables
Dim Left_orig As Integer
Dim Top_orig As Integer

'Event Declarations:
Event Click() 'MappingInfo=Command1,Command1,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=Command1,Command1,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=Command1,Command1,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=Command1,Command1,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=Command1,Command1,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=Command1,Command1,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=Command1,Command1,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Event Resize()
Attribute Resize.VB_Description = "Occurs when a form is first displayed or the size of an object changes."


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = Command1.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    Command1.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get ForeColor() As Long
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As Long)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = Command1.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    Command1.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = Command1.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set Command1.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = m_BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    m_BackStyle = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    m_BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    Command1.Refresh
End Sub

Private Sub Command1_Click()
    RaiseEvent Click
End Sub

Private Sub Command1_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub Command1_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub Command1_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub Command1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub Command1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Const delta As Integer = 100
    Static firstTime As Boolean
    If firstTime = False Then
        Left_orig = Extender.Left
        Top_orig = Extender.Top
        firstTime = True
    End If

    Timer1.Enabled = False
    Timer1.Enabled = True
    Extender.Parent.Bitmap = "distorted_face_bw.gif"
    If X > (Extender.Width / 2) Then
        Extender.Left = Extender.Left - delta
        If Y > (Extender.Height / 2) Then
            Extender.Top = Extender.Top - delta
        Else
            Extender.Top = Extender.Top + delta
        End If
    Else
        Extender.Left = Extender.Left + delta
        If Y > (Extender.Height / 2) Then
            Extender.Top = Extender.Top - delta
        Else
            Extender.Top = Extender.Top + delta
        End If
    End If
    If Extender.Top < 0 Or Extender.Top + Extender.Height > UserControl.Parent.ScaleHeight Then _
        Extender.Top = UserControl.Parent.ScaleHeight / 2 - Extender.Height / 2
    If Extender.Left < 0 Or Extender.Left + Extender.Width > UserControl.Parent.ScaleWidth Then _
        Extender.Left = UserControl.Parent.ScaleWidth / 2 - Extender.Width / 2
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub Command1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = Command1.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As Integer)
    Command1.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Cancel
Public Property Get Cancel() As Boolean
Attribute Cancel.VB_Description = "Indicates whether a command button is the Cancel button on a form."
    Cancel = Command1.Cancel
End Property

Public Property Let Cancel(ByVal New_Cancel As Boolean)
    Command1.Cancel() = New_Cancel
    PropertyChanged "Cancel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
    Caption = Command1.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    Command1.Caption() = New_Caption
    PropertyChanged "Caption"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,CausesValidation
Public Property Get CausesValidation() As Boolean
Attribute CausesValidation.VB_Description = "Returns/sets whether validation occurs on the control which lost focus."
    CausesValidation = Command1.CausesValidation
End Property

Public Property Let CausesValidation(ByVal New_CausesValidation As Boolean)
    Command1.CausesValidation() = New_CausesValidation
    PropertyChanged "CausesValidation"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,Default
Public Property Get Default() As Boolean
Attribute Default.VB_Description = "Determines which CommandButton control is the default command button on a form."
    Default = Command1.Default
End Property

Public Property Let Default(ByVal New_Default As Boolean)
    Command1.Default() = New_Default
    PropertyChanged "Default"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,DisabledPicture
Public Property Get DisabledPicture() As Picture
Attribute DisabledPicture.VB_Description = "Returns/sets a graphic to be displayed when the button is disabled, if Style is set to 1."
    Set DisabledPicture = Command1.DisabledPicture
End Property

Public Property Set DisabledPicture(ByVal New_DisabledPicture As Picture)
    Set Command1.DisabledPicture = New_DisabledPicture
    PropertyChanged "DisabledPicture"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,DownPicture
Public Property Get DownPicture() As Picture
Attribute DownPicture.VB_Description = "Returns/sets a graphic to be displayed when the button is in the down position, if Style is set to 1."
    Set DownPicture = Command1.DownPicture
End Property

Public Property Set DownPicture(ByVal New_DownPicture As Picture)
    Set Command1.DownPicture = New_DownPicture
    PropertyChanged "DownPicture"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,MaskColor
Public Property Get MaskColor() As Long
Attribute MaskColor.VB_Description = "Returns or sets a color in a button's picture to be a 'mask' (that is, transparent), if Style is set to 1."
    MaskColor = Command1.MaskColor
End Property

Public Property Let MaskColor(ByVal New_MaskColor As Long)
    Command1.MaskColor() = New_MaskColor
    PropertyChanged "MaskColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = Command1.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set Command1.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = Command1.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    Command1.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Command1,Command1,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
    ToolTipText = Command1.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    Command1.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

Private Sub Timer1_Timer()
    Extender.Left = Left_orig
    Extender.Top = Top_orig
    Timer1.Enabled = False
End Sub


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_ForeColor = m_def_ForeColor
    m_BackStyle = m_def_BackStyle
    m_BorderStyle = m_def_BorderStyle
End Sub


'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    Command1.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    Command1.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Command1.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_BackStyle = PropBag.ReadProperty("BackStyle", m_def_BackStyle)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    Command1.Appearance = PropBag.ReadProperty("Appearance", 1)
    Command1.Cancel = PropBag.ReadProperty("Cancel", False)
    Command1.Caption = PropBag.ReadProperty("Caption", "Command1")
    Command1.CausesValidation = PropBag.ReadProperty("CausesValidation", True)
    Command1.Default = PropBag.ReadProperty("Default", False)
    Set DisabledPicture = PropBag.ReadProperty("DisabledPicture", Nothing)
    Set DownPicture = PropBag.ReadProperty("DownPicture", Nothing)
    Command1.MaskColor = PropBag.ReadProperty("MaskColor", 12632256)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    Command1.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    Command1.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
End Sub

Private Sub UserControl_Resize()
    Command1.Left = 0
    Command1.Top = 0
    Command1.Width = Width
    Command1.Height = Height
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", Command1.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("Enabled", Command1.Enabled, True)
    Call PropBag.WriteProperty("Font", Command1.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", m_BackStyle, m_def_BackStyle)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Appearance", Command1.Appearance, 1)
    Call PropBag.WriteProperty("Cancel", Command1.Cancel, False)
    Call PropBag.WriteProperty("Caption", Command1.Caption, "Command1")
    Call PropBag.WriteProperty("CausesValidation", Command1.CausesValidation, True)
    Call PropBag.WriteProperty("Default", Command1.Default, False)
    Call PropBag.WriteProperty("DisabledPicture", DisabledPicture, Nothing)
    Call PropBag.WriteProperty("DownPicture", DownPicture, Nothing)
    Call PropBag.WriteProperty("MaskColor", Command1.MaskColor, 12632256)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", Command1.MousePointer, 0)
    Call PropBag.WriteProperty("ToolTipText", Command1.ToolTipText, "")
End Sub

